From d622d749d076e3d9fef06c1eecc9edc4bf82a576 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Sun, 11 Sep 2022 11:53:25 +0200
Subject: [PATCH 1/3] toulouse_maelis: correct comments in schema (#69046)

---
 passerelle/contrib/toulouse_maelis/schemas.py | 21 ++++++++-----------
 1 file changed, 9 insertions(+), 12 deletions(-)

diff --git a/passerelle/contrib/toulouse_maelis/schemas.py b/passerelle/contrib/toulouse_maelis/schemas.py
index 475dd5f7..8366b6cd 100644
--- a/passerelle/contrib/toulouse_maelis/schemas.py
+++ b/passerelle/contrib/toulouse_maelis/schemas.py
@@ -20,54 +20,51 @@ BOOLEAN_TYPES = [
     {'type': 'boolean'},
     {
         'type': 'string',
         'pattern': '^([Oo][Uu][Ii]|[Nn][Oo][Nn]|[Tt][Rr][Uu][Ee]|[Ff][Aa][Ll][Ss][Ee]|1|0)$',
         'pattern_description': 'Les valeurs "0", "1", "true", "false", "oui" ou "non" sont autorisées (insensibles à la casse).',
     },
 ]
 
-
 ID_PROPERTIES = {
     'firstname': {
         'description': 'Prénom',
         'type': 'string',
     },
     'lastname': {
         'description': 'Nom',
         'type': 'string',
     },
     'dateBirth': {
         'description': 'Date de naissance',
         'type': 'string',
         'pattern': '^[0-9]{4}-[0-9]{2}-[0-9]{2}$',
     },
 }
 
-
 LINK_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
     'title': 'Link',
     'description': "Appairage d'un usager Publik à une famille dans Maelis",
     'type': 'object',
     'required': ['family_id', 'firstname', 'lastname', 'dateBirth'],
     'properties': {
         'family_id': {
             'description': 'Numéro DUI',
             'type': 'string',
         },
     },
 }
 LINK_SCHEMA['properties'].update(ID_PROPERTIES)
 
-
 ISEXISTS_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Link',
-    'description': "Appairage d'un usager Publik à une famille dans Maelis",
+    'title': 'Exist',
+    'description': "Recherche d'un responsable légal ou d'un enfant dans Maelis",
     'type': 'object',
     'required': ['firstname', 'lastname', 'dateBirth'],
     'properties': ID_PROPERTIES,
 }
 
 ADDRESS_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
     'title': 'Address',
@@ -137,17 +134,17 @@ CONTACT_SCHEMA = {
                 },
             },
         },
     ],
 }
 
 ADDRESSPROF_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Contact',
+    'title': 'Adresse pro',
     'description': "Informations sur l'adresse professionnelle",
     'oneOf': [
         {'type': 'null'},
         {
             'type': 'object',
             'properties': {
                 'num': {
                     'description': "Numéro de l'adresse",
@@ -198,17 +195,17 @@ PROFESSION_SCHEMA = {
                 'addressPro': ADDRESSPROF_SCHEMA,
             },
         },
     ],
 }
 
 CAFINFO_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Contact',
+    'title': 'CAF',
     'description': 'Informations sur la CAF',
     'oneOf': [
         {'type': 'null'},
         {
             'type': 'object',
             'properties': {
                 'number': {
                     'description': "Numéro d'allocataire",
@@ -220,17 +217,17 @@ CAFINFO_SCHEMA = {
                 },
             },
         },
     ],
 }
 
 RLINFO_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'RLInfo',
+    'title': 'RL',
     'description': "Informations sur le responsable légal",
     'type': 'object',
     'required': ['firstname', 'lastname', 'civility', 'quality', 'dateBirth', 'adresse'],
     'properties': {
         'civility': {
             'description': 'civilité (depuis référenciel)',
             'oneOf': [{'type': 'null'}, {'type': 'string'}],
         },
@@ -448,17 +445,17 @@ MEDICALRECORD_SCHEMA = {
                 },
             },
         },
     ],
 }
 
 PAIINFO_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'PAI Info',
+    'title': 'PAI',
     'description': "Informations médicales",
     'oneOf': [
         {'type': 'null'},
         {
             'type': 'object',
             'properties': {
                 'code': {
                     'description': 'Code',
@@ -524,17 +521,17 @@ CHILD_SCHEMA = {
         'medicalRecord': MEDICALRECORD_SCHEMA,
         'paiInfoBean': PAIINFO_SCHEMA,
     },
 }
 CHILD_SCHEMA['properties'].update(ID_PROPERTIES)
 
 CONTACTLIGHT_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Contact',
+    'title': 'Contact light',
     'description': "Informations de contact pour les personnes autorisées à récupérer les enfants ou à prévenir en cas d'urgence",
     'oneOf': [
         {'type': 'null'},
         {
             'type': 'object',
             'properties': {
                 'phone': {
                     'description': 'Téléphone',
@@ -550,17 +547,17 @@ CONTACTLIGHT_SCHEMA = {
                 },
             },
         },
     ],
 }
 
 FAMILYPERSON_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Family',
+    'title': 'Family person',
     'description': "Informations sur les personnes autorisées à venir chercher les enfants ou à prévenir en cas d'urgence",
     'type': 'object',
     'required': ['firstname', 'lastname', 'dateBirth'],
     'properties': {
         'civility': {
             'description': 'civilité (depuis référenciel)',
             'oneOf': [{'type': 'null'}, {'type': 'string'}],
         },
@@ -571,17 +568,17 @@ FAMILYPERSON_SCHEMA = {
         'contact': CONTACTLIGHT_SCHEMA,
     },
     'unflatten': True,
 }
 FAMILYPERSON_SCHEMA['properties'].update(ID_PROPERTIES)
 
 AUTHORIZEDPERSON_SCHEMA = {
     '$schema': 'http://json-schema.org/draft-04/schema#',
-    'title': 'Family',
+    'title': 'Family persons',
     'description': "Informations sur les personnes autorisées à venir chercher les enfants ou à prévenir en cas d'urgence",
     'type': 'object',
     'properties': {
         'personList': {
             'oneOf': [
                 {'type': 'null'},
                 {
                     'type': 'array',
-- 
2.30.2